require LWP::UserAgent;
use MIME::Base64;

sub bc_split
{
	my $data = shift;
	my $ret = {};
	while($data =~ m{^(\S+)\s+(.+)$}mg)
	{
		$ret->{$1} = $2;
	}
	return $ret;
}

sub bc_post_data
{
	my ($url, $data) = @_;
	my $ua = LWP::UserAgent->new;
	my $resp = $ua->post($url, $data);
	my $con = $resp->decoded_content;
	return bc_split($con);
}

sub bc_submit_captcha
{
	my ($key, $fn) = @_;
	my $task_id = -1;
	return undef unless -e $fn;
	open F, $fn or return undef;
	binmode F;
	my $file_size = -s $fn;
	my $con;
	my $len = read (F, $con, $file_size, 0);
	return undef unless $len > 0;
	close F;
	$con = encode_base64($con);

	my $ret = bc_post_data(
		"http://bypasscaptcha.com/upload.php",
		{ "key" => $key, "file" => $con, "submit" => "Submit",
			"gen_task_id" => 1, "base64_code" => 1
		});
	my $v = {};
	if(exists $ret->{"TaskId"})
	{
		$v->{"task_id"} = $ret->{"TaskId"};
	}
	else 
	{
		return undef;
	}
	$v->{"value"} = $ret->{"Value"};
	$v->{"key"} = $key;

	return $v;
}

sub bc_submit_feedback
{
	my ($v, $is_input_correct) = @_;

	if($is_input_correct)
	{
		$is_input_correct = 1;
	}
	else
	{
		$is_input_correct = 0;
	}

	bc_post_data(
		"http://bypasscaptcha.com/check_value.php",
		{ "key" => $v->{key}, "task_id" => $v->{"task_id"}, 
			"cv" => $is_input_correct, "submit" => "Submit"
		});
}

sub bc_get_left
{
	my $key = shift;
	my $ret = bc_post_data(
		"http://bypasscaptcha.com/ex_left.php", 
		{ "key" => $key });
	return $ret->{"Left"};
}

